This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 794874 - Bugs found in libewf-20100226-4.fc17 using gcc-with-cpychecker static analyzer
Bugs found in libewf-20100226-4.fc17 using gcc-with-cpychecker static analyzer
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: libewf (Show other bugs)
19
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Nicolas Chauvet (kwizart)
Fedora Extras Quality Assurance
http://fedorapeople.org/~dmalcolm/gcc...
:
Depends On:
Blocks: cpychecker
  Show dependency treegraph
 
Reported: 2012-02-17 15:15 EST by Dave Malcolm
Modified: 2013-04-30 07:15 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-04-30 07:15:46 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Dave Malcolm 2012-02-17 15:15:49 EST
Description of problem:
I've been writing an experimental static analysis tool to detect bugs commonly occurring within C Python extension modules:
  https://fedorahosted.org/gcc-python-plugin/
  http://gcc-python-plugin.readthedocs.org/en/latest/cpychecker.html
  http://fedoraproject.org/wiki/Features/StaticAnalysisOfPythonRefcounts

I ran the latest version of the tool (in git master; post 0.9) on
libewf-20100226-4.fc17.src.rpm, and it reports various errors.

You can see a list of errors here, triaged into categories (from most significant to least significant):
http://fedorapeople.org/~dmalcolm/gcc-python-plugin/2012-02-17/libewf-20100226-4.fc17/

I've manually reviewed the bugs.

Within the category "Reference count too low" the 3 issues reported appear to be true bugs: the code should probably be using
   Py_RETURN_NONE;
rather than:
  return ( Py_None );
in order to add one to the reference count of Py_None; otherwise repeated calls could crash the interpreter.

Within the category "Reference leaks":
  pyewf_file.c:pyewf_file_read:ob_refcnt of '*result_data' is 1 too high
     Looks like a true memory leak

  pyewf_file.c:pyewf_file_get_header_values:ob_refcnt of '*dictionary_object' is 1 too high
    Looks like a memory leak for the case when this code fails:
      libewf_get_header_value_identifier_size unable to retrieve header value identifier size

  pyewf.c:pyewf_open:ob_refcnt of '*file_arguments' is 1 too high
    Looks like a memory leak for the case when Py_BuildValue() fails

Within the category "Segfaults within error-handling paths": the first three issues look like genuine crashers that could occur under low memory conditions.  The fourth is one-time only on import, so is unlikely to happen.

Within the category "Returning (PyObject*)NULL without setting an exception" the issues reported may be just a false positive.

There may of course be other bugs in my checker tool.

Hope this is helpful; let me know if you need help reading the logs that the tool generates - I know that it could use some improvement.

Version-Release number of selected component (if applicable):
libewf-20100226-4.fc17
gcc-python-plugin post-0.9 git 771455b3128b1323e80bdda53939d8d140a84c68 running the checker in an *f16* chroot
Comment 1 Nicolas Chauvet (kwizart) 2013-03-15 08:53:28 EDT
Is there a way to run the test against the newer version in fedora branched/f19 ?
There is a new libewf version there.
Comment 2 Fedora End Of Life 2013-04-03 11:47:36 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19
Comment 3 Nicolas Chauvet (kwizart) 2013-04-30 07:15:46 EDT
libewf was updated during the f19 development cycle,
please reproduce with this new version

Note You need to log in before you can comment on or make changes to this bug.